function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["children", "id", "initialIsOpen", "initialValue", "isInvalid", "onBlur", "onChange", "value"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { isNil } from 'lodash';
import React, { useCallback } from 'react';
import { useCombobox } from 'downshift';
import { getSelectedItem, itemToString as _itemToString, SelectLayout } from '../SelectBase';
import { NoResults } from './NoResults';
import { useHighlightedIndex } from './hooks/useHighlightedIndex';
import { useAutocomplete } from './hooks/useAutocomplete';
import { useMenuVisibility } from '../SelectBase/hooks/useMenuVisibility';
import { useExternalId } from '../../hooks/useExternalId';
import { useToggleButton } from './hooks/useToggleButton';
export var Autocomplete = function Autocomplete(_ref) {
  var children = _ref.children,
    externalId = _ref.id,
    initialIsOpen = _ref.initialIsOpen,
    initialValue = _ref.initialValue,
    _ref$isInvalid = _ref.isInvalid,
    isInvalid = _ref$isInvalid === void 0 ? false : _ref$isInvalid,
    onBlur = _ref.onBlur,
    onChange = _ref.onChange,
    value = _ref.value,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useAutocomplete = useAutocomplete(React.Children.toArray(children)),
    filteredItems = _useAutocomplete.filteredItems,
    hasError = _useAutocomplete.hasError,
    hasFilter = _useAutocomplete.hasFilter,
    inputRef = _useAutocomplete.inputRef,
    itemsMap = _useAutocomplete.itemsMap,
    onInputValueChange = _useAutocomplete.onInputValueChange,
    onIsOpenChange = _useAutocomplete.onIsOpenChange,
    _onSelectedItemChange = _useAutocomplete.onSelectedItemChange;
  var _useToggleButton = useToggleButton(inputRef),
    buttonRef = _useToggleButton.buttonRef,
    focusToggleButton = _useToggleButton.focusToggleButton,
    onInputEscapeKeyHandler = _useToggleButton.onInputEscapeKeyHandler,
    onToggleButtonKeyDownHandler = _useToggleButton.onToggleButtonKeyDownHandler;
  var id = useExternalId('autocomplete', externalId);
  var isControlled = value !== undefined;
  var _useCombobox = useCombobox(_objectSpread({
      initialIsOpen: initialIsOpen,
      items: filteredItems.map(function (item) {
        return item.props.value;
      }),
      itemToString: function itemToString(item) {
        return _itemToString(item, itemsMap);
      },
      onInputValueChange: onInputValueChange,
      onIsOpenChange: onIsOpenChange,
      onSelectedItemChange: function onSelectedItemChange(changes) {
        _onSelectedItemChange(changes);
        var newValue = changes.selectedItem;
        if (onChange) {
          onChange(newValue !== null && newValue !== void 0 ? newValue : null);
        }
        focusToggleButton();
      }
    }, _defineProperty({}, isControlled ? 'selectedItem' : 'initialSelectedItem', getSelectedItem(isControlled ? value : initialValue, itemsMap)))),
    getComboboxProps = _useCombobox.getComboboxProps,
    getInputProps = _useCombobox.getInputProps,
    getItemProps = _useCombobox.getItemProps,
    getMenuProps = _useCombobox.getMenuProps,
    getToggleButtonProps = _useCombobox.getToggleButtonProps,
    highlightedIndex = _useCombobox.highlightedIndex,
    inputValue = _useCombobox.inputValue,
    _useCombobox$isOpen = _useCombobox.isOpen,
    isOpen = _useCombobox$isOpen === void 0 ? false : _useCombobox$isOpen,
    openMenu = _useCombobox.openMenu,
    reset = _useCombobox.reset,
    selectedItem = _useCombobox.selectedItem,
    setHighlightedIndex = _useCombobox.setHighlightedIndex,
    setInputValue = _useCombobox.setInputValue;
  var _useHighlightedIndex = useHighlightedIndex(highlightedIndex, inputValue, isOpen, filteredItems, setHighlightedIndex, setInputValue),
    onInputBlurHandler = _useHighlightedIndex.onInputBlurHandler,
    onInputTabKeyHandler = _useHighlightedIndex.onInputTabKeyHandler;
  var _useMenuVisibility = useMenuVisibility(isOpen, openMenu),
    onInputFocusHandler = _useMenuVisibility.onInputFocusHandler;
  var handleInputBlur = useCallback(function () {
    onInputBlurHandler();
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    onBlur === null || onBlur === void 0 ? void 0 : onBlur.apply(void 0, args);
  }, [onBlur, onInputBlurHandler]);
  var handleInputScroll = useCallback(function (event) {
    var input = event.currentTarget;
    if (document.activeElement !== input && !hasFilter) {
      // Scroll to the beginning of the input in Firefox
      input.scrollLeft = 0;
    }
  }, [hasFilter]);
  var selectedItemText = isNil(selectedItem) || hasFilter ? '' : itemsMap[selectedItem].props.children;
  return /*#__PURE__*/React.createElement(SelectLayout, _extends({
    hasLabelFocus: isOpen,
    hasSelectedItem: !!inputValue,
    id: id,
    inputProps: getInputProps({
      onBlur: handleInputBlur,
      onFocus: onInputFocusHandler,
      onKeyDown: function onKeyDown(e) {
        onInputTabKeyHandler(e);
        onInputEscapeKeyHandler(e);
      },
      onScroll: handleInputScroll,
      ref: inputRef
    }),
    inputWrapperProps: getComboboxProps({
      'aria-expanded': isOpen
    }),
    isInvalid: hasError || isInvalid,
    isOpen: isOpen,
    menuProps: getMenuProps(),
    onClearButtonClick: function onClearButtonClick() {
      reset();
    },
    toggleButtonProps: getToggleButtonProps({
      onKeyDown: function onKeyDown(e) {
        onToggleButtonKeyDownHandler(e);
      },
      ref: buttonRef
    }),
    tooltipText: selectedItemText
  }, rest), isOpen && filteredItems.map(function (child, index) {
    return /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread(_objectSpread({}, child.props), getItemProps({
      index: index,
      item: child.props.value,
      key: "autocomplete-option-".concat(child.props.value)
    })), {}, {
      inputValue: inputValue,
      isHighlighted: highlightedIndex === index,
      title: child.props.children
    }));
  }), inputValue && !filteredItems.length && /*#__PURE__*/React.createElement(NoResults, null, inputValue));
};
Autocomplete.displayName = 'Autocomplete';